onload = function() {

	// template for "Template" cells
	var theTemplatebtn = '<button class="btn btn-default" name="{country}">' +
      '<img src="http://flagpedia.net/data/flags/mini/{abb}.png"/> ' +
      'Click Me!' +
    '</button>';
  var theTemplatea = '<a name="{country}">Edit</a>';

	// grid with template
	var theGrid = new wijmo.grid.FlexGrid('#theGrid', {
   	autoGenerateColumns: false,
    columns: [
    	{ binding: 'country', header: 'Country' },
      { binding: 'templatebtn', header: 'TemplateBtn', width: 130, isReadOnly: true },
      { binding: 'templatea', header: 'TemplateA', width: 130, isReadOnly: true },
      { binding: 'sales', header: 'Sales', format: 'n2' },
      { binding: 'expenses', header: 'Expenses', format: 'n2' }
    ],
  	itemsSource: getData(),
    showAlternatingRows: false,
		formatItem: function(s, e) {
    	if (e.panel == s.cells && s.columns[e.col].binding == 'templatebtn') {
      	var item = s.rows[e.row].dataItem,
      			html = wijmo.format(theTemplatebtn, item);
  			e.cell.innerHTML = html;
      }
      	if (e.panel == s.cells && s.columns[e.col].binding == 'templatea') {
      	var item = s.rows[e.row].dataItem,
      			html = wijmo.format(theTemplatea, item);
  			e.cell.innerHTML = html;
      }
    }
	});
  
  // make rows taller to accommodate buttons
  theGrid.rows.defaultSize = 45;

	// handle button clicks
  theGrid.hostElement.addEventListener('click', function(e) {
  	var target = wijmo.closest(e.target, 'button');
  	if (target instanceof HTMLButtonElement && target.name) {
    	alert('Thanks for clicking "' + target.name + '"');
    }
  });
  	// handle a clicks
  theGrid.hostElement.addEventListener('click', function(e) {
  	var target = wijmo.closest(e.target, 'a');
  	if (target instanceof HTMLAnchorElement && target.name) {
    	alert('Thanks for edit "' + target.name + '"');
    }
  });
  
	// create some random data
  function getData() {
    var countries = 'US,Germany,UK,Japan,Italy,Greece'.split(','),
        abb = 'us,de,gb,jp,it,gr'.split(','),
        data = [];
		for (var i = 0; i < countries.length; i++) {
    	data.push({
      	country: countries[i],
        abb: abb[i],
        sales: Math.random() * 10000,
        expenses: Math.random() * 5000
			});
		}
    return data;
  }
}
